//---------------------------------------------------------------------------

#include <vcl.h>
#include <math.h>
#include <math.hpp>
#pragma hdrstop

#include "Main.h"
#include "filterdesign.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

#define fq(x)   (exp((x-5)*0.0101)*10)
#define pox(f)  (Ceil(log(f/10)/0.0101)+5)
#define ody(od) (-Ceil(20*log10(od)*5)+150)
#define odp(od) (-Ceil(100.0/3.1412*(od))+150)
#define odys(od) (-Ceil((od*5))+150)

/*
        function fq(x:integer):real;
        begin
         result:=exp((x-5)*0.0202)*10;
        end;
        function pox(f:real):integer;
        begin
         result:=round(ln(f/10)/0.0202)+5;
        end;
        function ody(od:real):integer;
        begin
         ody:=round(20*log10(od));
        end;
*/

void __fastcall TForm1::Button1Click(TObject *Sender)
{
        //vykresli odezvu zadaneho filtru

        //osy
        im->Canvas->Brush->Style=bsSolid;
        im->Canvas->Brush->Color=clBlack;
        im->Canvas->Rectangle(im->Canvas->ClipRect);
        im->Canvas->Pen->Style=psSolid;
        im->Canvas->Pen->Color=clGray;
        im->Canvas->Font->Color=clGray;
        //frekvence
        for (int i=10;i<100;i+=10) {
                im->Canvas->MoveTo(pox(i),10);
                im->Canvas->LineTo(pox(i),320);
        }
        for (int i=100;i<1000;i+=100) {
                im->Canvas->TextOutA(pox(i)-3,2,(AnsiString)'.'+(AnsiString)IntToStr(i/100));
                im->Canvas->MoveTo(pox(i),10);
                im->Canvas->LineTo(pox(i),320);
        }
        for (int i=1000;i<24000;i+=1000) {
                im->Canvas->TextOutA(pox(i)-3,2,IntToStr(i/1000));
                im->Canvas->MoveTo(pox(i),10);
                im->Canvas->LineTo(pox(i),320);
        }
        //dB
        for (int i=-30;i<30;i+=3) {
                im->Canvas->MoveTo(4,odys(i));
                im->Canvas->LineTo(843,odys(i));
                im->Canvas->TextOutA(1,odys(i)-4,IntToStr(i));
        }
        //odezva filtru
        filter f;

        f.ftype=ComboBox1->ItemIndex;
        f.f0=500;
        f.dbGain=ScrollBar1->Position-20;
        f.Q=(float)ScrollBar2->Position/10;//SToQ(1,1000,20);

        im->Canvas->MoveTo(4,ody(FlAmp(f,1)));
        im->Canvas->Pen->Width=1;
        im->Canvas->Pen->Color=clBlue;
        for (int i=5;i<830;i++) {
         im->Canvas->LineTo(i,ody(FlAmp(f,fq(i))));
        }

        im->Canvas->Pen->Width=1;
        im->Canvas->MoveTo(4,odp(FlPha(f,1)));
        im->Canvas->Pen->Color=clRed;
        for (int i=5;i<830;i++) {
         im->Canvas->LineTo(i,odp(FlPha(f,fq(i))));
        }

        //koef.
        fdata fd;
        ComputeFilter(f, &fd);
        mem->Clear();
        mem->Lines->Add("a0 = "+FloatToStr(fd.a0));
        mem->Lines->Add("a1 = "+FloatToStr(fd.a1));
        mem->Lines->Add("a2 = "+FloatToStr(fd.a2));
        mem->Lines->Add("b0 = "+FloatToStr(fd.b0));
        mem->Lines->Add("b1 = "+FloatToStr(fd.b1));
        mem->Lines->Add("b2 = "+FloatToStr(fd.b2));
        //test odezvy
        im->Canvas->Pen->Width=1;
        im->Canvas->MoveTo(4,ody(FlAmp(f,1)));
        im->Canvas->Pen->Color=clWhite;
        if (!cbRealOdez->Checked) return;
        Application->ProcessMessages();
        for (int i=5;i<830;i++) {
        float p;
        float x[3];float y[3];
        x[0]=0;y[0]=0;y[1]=0;y[2]=0;x[1]=0;
        float inps=0,outs=0;
        for (int j=0;j<6000;j++) {
                p=sin(2*M_PI*fq(i)*j/Fs);
                y[0] = y[1];
                y[1] = y[2];
                x[0] = x[1];
                x[1] = x[2];
                x[2]=p;
                y[2] = (fd.b0/fd.a0)*x[2] + (fd.b1/fd.a0)*x[1] + (fd.b2/fd.a0)*x[0]
                        - (fd.a1/fd.a0)*y[1] - (fd.a2/fd.a0)*y[0];

                if (j>100) {
                        inps+=x[2]*x[2];
                        outs+=y[2]*y[2];
                }
                if (fabs(p)<0.005&&j>900) {
                        //ukoncit v nule
                        break;
                }
        }
//        ShowMessage(FloatToStr(sqrt(outs/inps)));
        if (outs/inps>0.001) {
         im->Canvas->LineTo(i,ody(sqrt(1e-6+outs/inps)));
                             }
        }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ScrollBar1Change(TObject *Sender)
{
 Label2->Caption=IntToStr(ScrollBar1->Position-20);
 Button1->Click();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ScrollBar2Change(TObject *Sender)
{
 Label4->Caption=FloatToStr((float)ScrollBar2->Position/10);
 Button1->Click();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
        Button1->Click();        
}
//---------------------------------------------------------------------------

