
void TASInit(void) {
	APResetOff();
	DelayMs(100);
	TASMute(TASM);
	{
		unsigned char data[5]={0xF9,1,128+64+1,4+8*4,3+16*3};
		i2cMasterSendNI(TASM, 5, data);
		DelayMs(80);
	}
	TASUnMute(TASM);
	TASMute(TASS);
	{
		unsigned char data[5]={0xF9,1,128+1,4+8*4,3+16*3};
		i2cMasterSendNI(TASS, 5, data);
		DelayMs(80);
	}
	TASUnMute(TASS);
	CodecResetOff();
	DelayMs(50);

	//nast. kodeku
	//vzorkovani
	{
		unsigned char data[2]={0x04,73};
		i2cMasterSendNI(CODEC, 2, data);
		DelayMs(10);
	}
	//single ended/dif. nastaveni, transition control
	{
		unsigned char data[3]={0x05,0x0C,64+32};
		i2cMasterSendNI(CODEC, 3, data);
		DelayMs(5);
	}


	//nastav hlasitosti na 0 dB
	{
		unsigned char data[5]={0xF2,0,0x80,0,0};
		i2cMasterSendNI(TASM, 5, data);
		DelayMs(1);
		data[0]=0xF3;
		i2cMasterSendNI(TASM, 5, data);
		DelayMs(1);
		data[0]=0xF4;
		i2cMasterSendNI(TASM, 5, data);
		DelayMs(1);

		//bypass
		data[0]=0xCC;
		i2cMasterSendNI(TASM, 5, data);
		DelayMs(1);
		data[0]=0xCF;
		i2cMasterSendNI(TASM, 5, data);
		DelayMs(1);
	}
}

void CSSetVolume() {
}

void CSSetIn(unsigned char in) {
	unsigned char data[2]={0x05,0x0C+in ? 3 : 0};
	i2cMasterSendNI(CODEC, 2, data);
	DelayMs(3);
}

